/******************************************
*  I2C ʐMCu
******************************************/
#include <htc.h>
#include "i2c_lib4.h"

/*************************************
* I2C1oCgf[^M
**************************************/
void SendI2C(unsigned Adrs, unsigned char Data)
{
    IdleI2C();
    SSPCON2bits.SEN = 1;   		// 
    while(SSPCON2bits.SEN);		// 
    SendByte(Adrs);                     // 
    SendByte(Data);                     // 
    SSPCON2bits.PEN = 1;   		// 
    while(SSPCON2bits.PEN);		// 
}
/****************************************
* I2CoXgăR}hM
*****************************************/
void CmdI2C(unsigned Adrs, unsigned Reg, unsigned char Data)
{
    IdleI2C();
    SSPCON2bits.SEN = 1;   		// X^[gó@//
    while(SSPCON2bits.SEN);		// X^[gI
    SendByte(Adrs);                     // AhX{M[hM
    SendByte(Reg);                      // WX^w著M
    SendByte(Data);                     // R}hf[^M
    SSPCON2bits.PEN = 1;   		// Xgbvo
    while(SSPCON2bits.PEN);		// XgbvI҂
}
/** ACh҂Tu֐@***/
void IdleI2C(void){
    while(SSPCON2bits.SEN || SSPCON2bits.PEN || SSPCON2bits.RCEN
            || SSPCON2bits.ACKEN || SSPSTATbits.R_nW);
}
/****************************************
*I2CłPoCgM
*****************************************/
void SendByte(unsigned char ch){
    SSPBUF = ch;			//@f[^ZbgMJn 
    while(SSPSTATbits.BF);		// MI҂
    while(SSPCON2bits.ACKSTAT);        	//@ACKԐM҂
    IdleI2C();				// ACh҂
}
/*****************************************
* I2CoXgĂoCgM
******************************************/
void GetDataI2C(unsigned char Adrs, unsigned char *Buffer, unsigned char Cnt)
{
    unsigned char i;

    IdleI2C();				// ACh҂
    SSPCON2bits.SEN = 1;   		// X^[go
    while(SSPCON2bits.SEN);		// X^[gI҂
    SendByte(Adrs+1);                   // AhX{M[hM    
    for(i=0; i<Cnt; i++)
        Buffer[i] = RcvByte(0);         // PoCgM@ACK
    Buffer[i] = RcvByte(1);             // ŏIoCgMNACK
    SSPCON2bits.PEN = 1;   		// Xgbvo
    while(SSPCON2bits.PEN);		// XgbvI҂
}
/****************************************
* I2CłPoCgM@ACK/NACK@ԑ
*****************************************/
unsigned char RcvByte(unsigned char Ans){
    unsigned char data;
    
    SSPCON2bits.ACKDT = Ans;		// ACK(0)/NackiPjݒ
    SSPCON2bits.RCEN = 1;		// M@RCENZbg
    while(!SSPSTATbits.BF);            	// M҂BF`FbN
    SSPCON2bits.ACKEN = 1;		// ASKԑ
    data = SSPBUF;			// Mf[^擾
    SSPCON1bits.SSPOV = 0;		// G[NA
    IdleI2C();				// ACh҂
    return(data);			//Mf[^Ԃ
}
