/*****************************************************
 * PIC16F1938@hQb@ʐM
 * @hQb@foCX
 * @VAddoqnl@QSLbUS
 * @2019/04/15
 * 
 * @2023/11/03
******************************************************/
#include <xc.h>
#include <stdio.h>
#include  "i2c_lib4.h"

/*****RtBO[Vݒ*********/
__CONFIG(FOSC_INTOSC & WDTE_OFF & PWRTE_ON & MCLRE_ON & CP_OFF
    & CPD_OFF & BOREN_ON & CLKOUTEN_OFF & IESO_OFF & FCMEN_OFF);
__CONFIG(WRT_OFF & PLLEN_OFF & STVREN_OFF & LVP_OFF);

#define  _XTAL_FREQ     8000000

void putch(unsigned char byte);							//VAʐMp
void EEWrite(unsigned int EEAdrs, unsigned char Data);//EEPROPf[^ݗp
unsigned char EERead(unsigned int EEAdrs);				//EEPROPf[^ǂݍݗp


/********@C֐@@************/
void main(void) {
	unsigned int eepdata;		//ddoqnl@f[^p
	unsigned int eepaddr;		//ddnqnl@AhXp

	/*******ݒ******/
    OSCCON = 0x72;                          //NbNWHMzw(BPLL Off
    ANSELA = 0x00;                          //A/D~
    ANSELB = 0x00;							//A/D~
    TRISA  = 0b00000000;					//
    TRISB  = 0b00000000;                    //
    TRISC  = 0b10011000;                    //SCLSDÃ|[g͓͐ݒ
	
    /***** IC2ݒ********/
    SSPSTAT = 0b10000000;					//@ԃNA
    SSPCON1 = 0b00101000;                   // I2C@Cl[u
    SSPADD = 0x13;                          // 100kHz@32MHz
 
    /****** UARTݒ *****/
    TXSTA = 0x26;                           //VAMݒ@0x24@łok?
    RCSTA = 0x90;                           //VAMݒ
    BAUDCON=0x08;                           //
    SPBRG = 103;                            //{[[gݒ (19.2kbps)

        GIE = 0;                            //荞ݖ

	/************@@EEPROM eXgX^[g@@********************/
        __delay_ms(500);                    //dON^[~i\tgƐڑ܂
                                             //Ԃ̂5bقǑ҂
		printf("\r\n HELLO ! Ver.1 \r\n");
		printf("EEPROM TEST0 \r\n");
		printf("\r\n");
        
        for(eepaddr=0; eepaddr<0x0a; eepaddr++)
        {
            eepdata = EERead(eepaddr);				//EEROMǂݍ
            printf("Adr %04X h = %02X \r\n",eepaddr,eepdata);
            __delay_ms(100);                    //
        }
        
        printf("\r\n");
		printf("EEPROM TEST1 \r\n");
		EEWrite(0x0000,0x11);				//AhX0000h11h
		EEWrite(0x0001,0x22);				//AhX0001h22h
		EEWrite(0x0002,0x33);				//AhX0002h33h
		EEWrite(0x0003,0x44);				//AhX0003h44h
		EEWrite(0x0004,0x55);				//AhX0004h55h
		EEWrite(0x0005,0x66);				//AhX0005h66h
		EEWrite(0x0006,0x77);				//AhX0006h77h
		EEWrite(0x0007,0x88);				//AhX0007h88h
 		EEWrite(0x0008,0x99);				//AhX0008h99h
		EEWrite(0x0009,0xaa);				//AhX0009haah
		EEWrite(0x000a,0xbb);				//AhX000Ahbbh
		EEWrite(0x000b,0xcc);				//AhX000Bhcch
		EEWrite(0x000c,0xdd);				//AhX000Chddh
		EEWrite(0x000d,0xee);				//AhX000Dheeh
		EEWrite(0x000e,0xff);				//AhX000Ehffh
		EEWrite(0x000f,0x12);				//AhX000Fh12h
        EEWrite(0x1FFE,0xf1);				//AhX1FFEhf1h
		EEWrite(0x1FFF,0xf2);				//AhX1FFFhf2h

		__delay_ms(250);                    //
        for(eepaddr=0; eepaddr<0x10; eepaddr++)
        {
            eepdata = EERead(eepaddr);				//AhX0000hǂݍ
            printf("Adr %04X h = %02X \r\n",eepaddr,eepdata);
            __delay_ms(100);                    //
        }

            eepdata = EERead(0x1FFE);				//AhX1FFEhǂݍ(8kbyt)
            printf("Adr 1FFE h = %02X \r\n",eepdata);
            __delay_ms(100);        @
        
            eepdata = EERead(0x1FFF);				//AhX1FFFhǂݍ(8kbyt)
            printf("Adr 1FFF h = %02X \r\n",eepdata);
            __delay_ms(100);        
    
        //dꂽɊmFp̃f[^
        for(eepaddr=0; eepaddr<0x10; eepaddr++)
        {
            EEWrite(eepaddr,0xBB);				//00h`0FhBBh  
            __delay_ms(5);                    //
        }
            
        printf("TEST SPOT\r\n");
		while (1) {		}
}

/****************************************
 * USART p
 **********************************/
void putch(unsigned char byte){
		
		RCSTAbits.SPEN=1;
		TXREG=byte;
		while(!TXIF)continue;
		TXIF=0;
}

/****************************************************************************
 * I2C foCXƂ̒ʐM
 ****************************************************************************/

/*************************************
* EEPROM 1oCg݊֐
 * `bvAhX@A0h
**************************************/
void EEWrite(unsigned int EEAdrs, unsigned char Data){
    unsigned int i;
    IdleI2C();							//ACh҂
    SSPCON2bits.SEN = 1;				//X^[go
    while(SSPCON2bits.SEN);				//X^[gI҂
    SendByte(0xA0);						//݃[hMi`bvAhXj
    SendByte((EEAdrs >> 8) & 0xFF);		//݃AhXʑM
    SendByte(EEAdrs & 0xFF);			//݃AhXʑM
    SendByte(Data);						//݃f[^M
    SSPCON2bits.PEN = 1;				//Xgbvo
    while(SSPCON2bits.PEN);				//XgbvI҂
	__delay_ms(5);						//݊҂
										//2msȏ̃EGCgKv
}
/*************************************
* EEPROM 1oCgǂݏo֐
**************************************/
unsigned char EERead(unsigned int EEAdrs){
    unsigned char result;

    IdleI2C();							//ACh҂
    SSPCON2bits.SEN = 1;				//X^[go
    while(SSPCON2bits.SEN);				//X^[g҂
    SendByte(0xA0);						//݃[hMi`bvAhXj
    SendByte((EEAdrs >> 8) & 0xFF);		//݃AhXʑM
    SendByte(EEAdrs & 0xFF);			//݃AhXʑM
    /***** ǂݏo *******/
    SSPCON2bits.ACKDT = 1;				//Nack(1)ݒ)
    SSPCON2bits.SEN = 1;				//X^[go
    while(SSPCON2bits.SEN);				//X^[gI҂
        SendByte(0xA1);					//ǂݍ݃[hMi`bvAhXj
    SSPCON2bits.RCEN = 1;				//M
    while(!SSPSTATbits.BF);				//M҂@BF`FbN
    SSPCON2bits.ACKEN = 1;				//NACKԑ
    IdleI2C();							//ACh҂
    result = SSPBUF;					//Mf[^擾
    SSPCON1bits.SSPOV = 0;				//G[NA[
    SSPCON2bits.PEN = 1;				//Xgbvo
    while(SSPCON2bits.PEN);				//XgbvI҂
    return(result);						//ǂݏof[^Ԃ
}

